//===================================================================
//	pas1000w.h
//
//	Copyright (C) P&A Technologies Inc.
//===================================================================
#pragma once

namespace Sample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Data;
	using namespace System::Runtime::InteropServices;
	using namespace System::Diagnostics;

	public ref class pas1000
	{
	public:
		//-----------------------------------------------------------
		// foCXANZXɊւ`
		//-----------------------------------------------------------
		literal unsigned int MAX_DEVICE = 16;							// őfoCX
		literal unsigned short DEVICE_AUTO = 0xFFFF;					// foCXw

		//-----------------------------------------------------------
		// `lɊւ`
		//-----------------------------------------------------------
		literal int ANALOG_NUM_CH = 8;									// AiO`l
		literal int EXTRIG_NUM_CH = 8;									// OgK`l
		literal int DIGITALOUT_NUM_CH = 4;								// fW^o̓`l

		//-----------------------------------------------------------
		// foCXɊւ`
		//-----------------------------------------------------------
		literal int VID_LENGTH = 8;										// x_ʕ
		literal int PID_LENGTH = 16;									// v_Ngʕ

		//-----------------------------------------------------------
		// ԏɊւ`
		//-----------------------------------------------------------
		literal int DATE_TIME_LENGTH = 7;								// ̒(N//(j) ::b)
		literal int START_TIME_LENGTH = 5;								// X^[g^C̒(///b/~b)

		//-----------------------------------------------------------
		// Xe[^XɊւ`
		//-----------------------------------------------------------
		literal unsigned int STOP_LOGGING = 0x00;						// MO~
		literal unsigned int RUNNING_LOGGING = 0x01;					// MOs
		literal unsigned int REACH_START_TIME = 0x02;					// X^[g^CɒB
		literal unsigned int PRE_START_TRIGPOS = 0x04;					// X^[ggK|WVɒBO
		literal unsigned int WAIT_START_TRIG = 0x08;					// X^[ggK҂
		literal unsigned int DETECT_START_TRIG = 0x10;					// X^[ggKo
		literal unsigned int PRE_STOP_TRIGPOS = 0x20;					// XgbvgK|WVɒBO
		literal unsigned int WAIT_STOP_TRIG = 0x40;						// XgbvgK҂
		literal unsigned int DETECT_STOP_TRIG = 0x80;					// XgbvgKo

		//-----------------------------------------------------------
		// G[R[h̒`
		//-----------------------------------------------------------
		literal unsigned int SUCCESS = 0x00;							// ُȂ
		literal unsigned int ERR_SYSTEM = 0x01;							// VXeG[
		literal unsigned int ERR_NO_DEVICE = 0x02;						// gp\ȃfoCX܂
		literal unsigned int ERR_IN_USE = 0x03;							// w̃foCX͎gpł
		literal unsigned int ERR_INVALID_DEVICENO = 0x04;				// sȃfoCXʔԍł
		literal unsigned int ERR_INVALID_ARGUMENT = 0x05;				// sȈw肳܂
		literal unsigned int ERR_INTERNAL = 0x06;						// G[ł
		literal unsigned int ERR_TRANSFER_TIMEOUT = 0x07;				// f[^]^CAEgɂȂ܂
		literal unsigned int ERR_TRANSFER_CANCEL = 0x08;				// f[^]LZ܂
		literal unsigned int ERR_TRANSFER_FAIL = 0x09;					// f[^]s܂
		literal unsigned int ERR_TRANSFER_SIZE = 0x0A;					// f[^]̃TCYsł
		literal unsigned int ERR_HARDBUFF_OVERRUN = 0x0B;				// n[hobt@I[o[܂
		literal unsigned int ERR_SOFTBUFF_OVERRUN = 0x0C;				// \tgobt@I[o[܂
		literal unsigned int ERR_DEVICE = 0x0D;							// foCXG[ł
		literal unsigned int ERR_WRAPDLL = 0xFFFF;						// DLL ̃[hɎs܂

		literal unsigned int ERR_ANALOG_SETTING = 0x01;					// AiOɊւݒŕsȈw肳܂
		literal unsigned int ERR_DIGITAL_SETTING = 0x04;				// fW^ɊւݒŕsȈw肳܂
		literal unsigned int ERR_ALARM_SETTING = 0x05;					// A[ɊւݒŕsȈw肳܂
		literal unsigned int ERR_TRIGMODE_SETTING = 0x06;				// gK[hɊւݒŕsȈw肳܂
		literal unsigned int ERR_EXTRIG_SETTING = 0x07;					// OgKɊւݒŕsȈw肳܂

		// AiOɊւݒŕsȈw肳܂
		literal unsigned int ERR_ANALOG_CH_ENABLE = 0x10;				// `lgp
		literal unsigned int ERR_ANALOG_TYPE = 0x11;					// ^Cv
		literal unsigned int ERR_ANALOG_RANGE = 0x12;					// W
		literal unsigned int ERR_ANALOG_BURNOUT = 0x13;					// o[AEg
		literal unsigned int ERR_ANALOG_COLDJUNCCOMP = 0x14;			// ړ_⏞
		literal unsigned int ERR_ANALOG_SAMPLINGMODE = 0x15;			// TvO[h
		literal unsigned int ERR_ANALOG_SAMPLINGTIME = 0x16;			// TvO^C
		literal unsigned int ERR_ANALOG_STARTTIME_ENABLE = 0x17;		// X^[g^Cgp
		literal unsigned int ERR_ANALOG_STARTTIME = 0x18;				// X^[g^C
		literal unsigned int ERR_ANALOG_LOGGINGSIZE = 0x19;				// MOTCY
		literal unsigned int ERR_ANALOG_STARTTRIG_ENABLE = 0x1A;		// X^[ggKgp
		literal unsigned int ERR_ANALOG_STARTTRIG_CH = 0x1B;			// X^[ggK`l
		literal unsigned int ERR_ANALOG_STARTTRIG_MODE = 0x1C;			// X^[ggK[h
		literal unsigned int ERR_ANALOG_STARTTRIG_SENSE = 0x1D;			// X^[ggKo[h
		literal unsigned int ERR_ANALOG_STARTTRIG_LEVEL = 0x1E;			// X^[ggKx
		literal unsigned int ERR_ANALOG_STARTTRIG_POS = 0x1F;			// X^[ggK|WV
		literal unsigned int ERR_ANALOG_STOPTRIG_ENABLE = 0x20;			// XgbvgKgp
		literal unsigned int ERR_ANALOG_STOPTRIG_CH = 0x21;				// XgbvgK`l
		literal unsigned int ERR_ANALOG_STOPTRIG_MODE = 0x22;			// XgbvgK[h
		literal unsigned int ERR_ANALOG_STOPTRIG_SENSE = 0x23;			// XgbvgKo[h
		literal unsigned int ERR_ANALOG_STOPTRIG_LEVEL = 0x24;			// XgbvgKx
		literal unsigned int ERR_ANALOG_STOPTRIG_POS = 0x25;			// XgbvgK|WV

		// OgKɊւݒŕsȈw肳܂
		literal unsigned int ERR_EXTRIG_SLOPE = 0x30;					// X[v
		literal unsigned int ERR_EXTRIG_FILTER = 0x31;					// tB^

		// A[ɊւݒŕsȈw肳܂
		literal unsigned int ERR_ALARM_ANALOG_ENABLE = 0x40;			// AiOgp
		literal unsigned int ERR_ALARM_ANALOG_MODE = 0x41;				// AiO[h
		literal unsigned int ERR_ALARM_ANALOG_SENSE = 0x42;				// AiOo[h
		literal unsigned int ERR_ALARM_ANALOG_LEVEL = 0x43;				// AiOx
		literal unsigned int ERR_ALARM_ANALOG_PORTOUT_ENABLE = 0x44;	// AiO|[go͏
		literal unsigned int ERR_ALARM_ANALOG_PORTOUT_CH = 0x45;		// AiO|[go̓`l
		literal unsigned int ERR_ALARM_EXTRIG_ENABLE = 0x4A;			// OgKgp
		literal unsigned int ERR_ALARM_EXTRIG_CH = 0x4B;				// OgK`l
		literal unsigned int ERR_ALARM_EXTRIG_PORTOUT_ENABLE = 0x4C;	// OgK|[go͏
		literal unsigned int ERR_ALARM_EXTRIG_PORTOUT_CH = 0x4D;		// OgK|[go̓`l

		// fW^o͂ɊւݒŕsȈw肳܂
		literal unsigned int ERR_DIGITALOUT_TYPE = 0x50;				// o̓^Cv
		literal unsigned int ERR_DIGITALOUT_LEVEL = 0x51;				// o͘_

		// foCXG[
		literal unsigned int ERR_FPGA_SETTING = 0x10;					// FPGA:ݒ菈ُł
		literal unsigned int ERR_RTC_INIT = 0x20;						// RTC:CjVCYُł
		literal unsigned int ERR_RTC_DATA_ACCESS = 0x21;				// RTC:f[^]ANZXُł
		literal unsigned int ERR_RTC_DATA_SETTING = 0x22;				// RTC:f[^ݒ肪ُł
		literal unsigned int ERR_RTC_TIME_SETTING = 0x23;				// RTC:ݒ肪ُł

		//-----------------------------------------------------------
		// bZ[W̒`
		//-----------------------------------------------------------
		literal int WM_REMOVAL = 1;										// foCX
		literal int WM_INSERT = 2;										// foCX}
		literal int WM_ERROR = 3;										// f[^擾XbhG[

		//-----------------------------------------------------------
		// ̑̒`
		//-----------------------------------------------------------
		literal unsigned int DEVICE_ID = 0x5310;						// foCXID
		literal String^ DLL_NAME = "pas1000.dll";						// DLLt@C

	public:
		// foCX\
		[StructLayout(LayoutKind::Sequential)]
		value class TDEVINFO
		{
		public:
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = VID_LENGTH)]
			array<Byte>^ bVendorID;										// x_ʕ
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = PID_LENGTH)]
			array<Byte>^ bProductID;									// v_Ngʕ
			Byte bFirmVer;												// t@[EFÃo[W
			Byte bFpgaVer;												// FPGÃo[W
			Byte bUsbMode;												// USB][h
		};

		//-----------------------------------------------------------
		// 샂[hp[^\
		//-----------------------------------------------------------
	public:
		// gK@\\
		[StructLayout(LayoutKind::Sequential)]
		value class TTRIG
		{
		public:
			unsigned int dwEnable;										// gKgpԂ̐ݒ
			unsigned int dwCh;											// gK`l̐ݒ
			unsigned int dwMode;										// gK[h̐ݒ
			unsigned int dwSense;										// gKo[h̐ݒ
			unsigned int dwLevel0;										// gKx0̐ݒ
			unsigned int dwLevel1;										// gKx1̐ݒ
			unsigned long long dwPos;									// gK|WV̐ݒ
		};

	public:
		// AiO@\\(`lʂ̐ݒ)
		[StructLayout(LayoutKind::Sequential)]
		value class TANALOGCH
		{
		public:
			unsigned int dwChEnable;									// AiO`l̐ݒ
			unsigned int dwType;										// AiO^Cv̐ݒ
			unsigned int dwRange;										// AiO̓W̐ݒ
			unsigned int dwBurnOut;										// AiOo[AEg̐ݒ
			unsigned int dwColdJuncComp;								// AiOړ_⏞̐ݒ
		};

	public:
		// AiO@\\
		[StructLayout(LayoutKind::Sequential)]
		value class TANALOG
		{
		public:
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = ANALOG_NUM_CH)]
			array<TANALOGCH>^ Ch;										// AiO`lʂ̐ݒ
			TTRIG StartTrig;											// AiOX^[ggK̐ݒ
			TTRIG StopTrig;												// AiOXgbvgK̐ݒ
			unsigned int dwSamplingMode;								// AiOTvO[h̐ݒ
			unsigned int dwSamplingTime;								// AiOTvO^C̐ݒ
			unsigned int dwStartTimeEnable;								// AiOX^[g^CgpԂ̐ݒ
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = START_TIME_LENGTH)]
			array<unsigned int>^ dwStartTime;							// AiOX^[g^C̐ݒ
			unsigned long long dwLoggingSize;							// AiOMOTCY̐ݒ
		};

	public:
		// OgK\
		[StructLayout(LayoutKind::Sequential)]
		value class TEXTRIG
		{
		public:
			unsigned int dwInSlope;										// ̓X[v
			unsigned int dwInFilter;									// ̓tB^
		};

	public:
		// A[@\̃AiO\
		[StructLayout(LayoutKind::Sequential)]
		value class TALARMANALOG
		{
		public:
			unsigned int dwEnable;										// A[gpԂ̐ݒ
			unsigned int dwMode;										// A[[h̐ݒ
			unsigned int dwSense;										// A[o[h̐ݒ
			unsigned int dwLevel0;										// A[x0̐ݒ
			unsigned int dwLevel1;										// A[x1̐ݒ
			unsigned int dwPortOutEnable;								// A[|[go͏Ԃ̐ݒ
			unsigned int dwPortOutCh;									// A[|[go̓`l̐ݒ
		};

	public:
		// A[@\̊OgK\
		[StructLayout(LayoutKind::Sequential)]
		value class TALARMEXTRIG
		{
		public:
			unsigned int dwEnable;										// A[gpԂ̐ݒ
			unsigned int dwCh;											// A[`l̐ݒ
			unsigned int dwPortOutEnable;								// A[|[go͏Ԃ̐ݒ
			unsigned int dwPortOutCh;									// A[|[go̓`l̐ݒ
		};

	public:
		// A[@\\
		[StructLayout(LayoutKind::Sequential)]
		value class TALARM
		{
		public:
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = ANALOG_NUM_CH)]
			array<TALARMANALOG>^ Analog;								// AiÕA[v̐ݒ
			TALARMEXTRIG ExTrig;										// OgK̃A[v̐ݒ
		};

	public:
		// fW^o͍\
		[StructLayout(LayoutKind::Sequential)]
		value class TDIGITALOUT
		{
		public:
			unsigned int dwType;										// fW^o̓^Cv̐ݒ
			unsigned int dwLevel;										// fW^o͘_̐ݒ
		};

	public:
		// 샂[h\
		[StructLayout(LayoutKind::Sequential)]
		value class TSETMODE
		{
		public:
			TANALOG Analog;												// AiO@\
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = EXTRIG_NUM_CH)]
			array<TEXTRIG>^ ExTrig;										// OgK@\
			TALARM Alarm;												// A[@\
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = DIGITALOUT_NUM_CH)]
			array<TDIGITALOUT>^ DigitalOut;								// fW^o
		};

		//-----------------------------------------------------------
		// `lƂ̃Xe[^X\
		//-----------------------------------------------------------
	public:
		// MOXe[^X\
		[StructLayout(LayoutKind::Sequential)]
		value class TLOGGINGSTS
		{
		public:
			[MarshalAs(UnmanagedType::ByValArray, SizeConst = ANALOG_NUM_CH)]
			array<unsigned int>^ dwAnalog;								// AiO
		};

	public:
		// `lXe[^X\
		[StructLayout(LayoutKind::Sequential)]
		value class TCHSTATUS
		{
		public:
			TLOGGINGSTS LoggingStatus;									// MOXe[^X
			unsigned int dwAlarmStatus;									// A[Xe[^X
		};

		//-----------------------------------------------------------
		// API
		//-----------------------------------------------------------
	public:
		// 
		[DllImport(DLL_NAME)]
		static bool Pas1000Initialize(int hWnd, unsigned int uWMBase, short TimeOut);

		// foCX̌
		[DllImport(DLL_NAME)]
		static bool Pas1000Create(unsigned short* pwDeviceNo);

		// foCX̊J
		[DllImport(DLL_NAME)]
		static bool Pas1000Close(unsigned short wDeviceNo);

		// I
		[DllImport(DLL_NAME)]
		static bool Pas1000Terminate();

		// o[W擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetVersion(unsigned int* pdwDrvVer, unsigned int* pdwDllVer);

		// foCX擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetDevInfo(unsigned short wDeviceNo, IntPtr pDevInfo);

		// jbgID̐ݒ
		[DllImport(DLL_NAME)]
		static bool Pas1000SetUnitId(unsigned short wDeviceNo, unsigned int dwUnitId);

		// jbg擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetUnitInfo(unsigned short wDeviceNo, unsigned int* pdwUnitId, unsigned int* pdwNumCh);

		// ̐ݒ
		[DllImport(DLL_NAME)]
		static bool Pas1000SetTime(unsigned short wDeviceNo, IntPtr pdwHostTime);

		// 擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetTime(unsigned short wDeviceNo, IntPtr pdwFirmTime,
									IntPtr pdwFpgaTime, unsigned int* pdwAdjustStatus);

		// 샂[h̐ݒ
		[DllImport(DLL_NAME)]
		static bool Pas1000SetMode(unsigned short wDeviceNo, IntPtr pSetMode);

		// fW^͂̓ǂݍ
		[DllImport(DLL_NAME)]
		static bool Pas1000DigitalIn(unsigned short wDeviceNo, Byte* pbDigitalInValue);

		// fW^o͂̏
		[DllImport(DLL_NAME)]
		static bool Pas1000DigitalOut(unsigned short wDeviceNo, Byte bDigitalOutValue);

		// A[̃NA
		[DllImport(DLL_NAME)]
		static bool Pas1000AlarmClear(unsigned short wDeviceNo, unsigned int dwNumCh);

		// MO̊Jn
		[DllImport(DLL_NAME)]
		static bool Pas1000StartLogging(unsigned short wDeviceNo, unsigned int dwStartMode);

		// MO̒~
		[DllImport(DLL_NAME)]
		static bool Pas1000StopLogging(unsigned short wDeviceNo);

		// `lʂ̃Xe[^X擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetStatus(unsigned short wDeviceNo, unsigned int* pdwHardNumData, unsigned int* pdwSoftNumData,
										unsigned int* pdwLoggingStatus, unsigned int* pdwOverrunError);

		// `lƂ̃Xe[^X擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetChStatus(unsigned short wDeviceNo, IntPtr pChStatus);

		// MOf[^擾
		[DllImport(DLL_NAME)]
		static bool Pas1000GetData(unsigned short wDeviceNo, unsigned int dwNumData, IntPtr pbData);

		// G[R[h擾
		[DllImportAttribute(DLL_NAME, SetLastError = true)]
		static unsigned int Pas1000GetLastError(unsigned short wDeviceNo);

		//-----------------------------------------------------------
		// 		
		// 		hWnd		DLLo郁bZ[W󂯎EBhẼnh
		//			uWMBase		o郁bZ[WID̃x[Xl
		//			TimeOut		USB ]҂̃^CAEg
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool Initialize(int hWnd, unsigned int uWMBase, short TimeOut)
			{
				try
				{
					return Pas1000Initialize(hWnd, uWMBase, TimeOut);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		foCX̌
		// 		pwDeviceNo	gpfoCX̃foCXʔԍi[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool Create(unsigned short* pwDeviceNo)
			{
				try
				{
					return Pas1000Create(pwDeviceNo);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		foCX̊J
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool Close(unsigned short wDeviceNo)
			{
				try
				{
					return Pas1000Close(wDeviceNo);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		I
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool Terminate()
			{
				try
				{
					return Pas1000Terminate();
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		o[W擾
		// 		pdwDrvVer	hCõo[Wi[̈ւ̃|C^
		//			pdwDllVer	DLL̃o[Wi[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetVersion(unsigned int* pdwDrvVer, unsigned int* pdwDllVer)
			{
				try
				{
					return Pas1000GetVersion(pdwDrvVer, pdwDllVer);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		foCX擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pDevInfo	foCXi[\̂ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetDevInfo(unsigned short wDeviceNo, TDEVINFO% pDevInfo)
			{
				try
				{
					bool res;
					IntPtr ptr;

					ptr = Marshal::AllocHGlobal(Marshal::SizeOf(pDevInfo));	// A}l[Wm
					Marshal::StructureToPtr(pDevInfo, ptr, false);			// }[VO(}l[W->A}l[W)
					res = Pas1000GetDevInfo(wDeviceNo, ptr);
					pDevInfo = safe_cast<TDEVINFO>(Marshal::PtrToStructure(ptr, TDEVINFO::typeid));	// }[VO(A}l[W->}l[W)
					Marshal::FreeHGlobal(ptr);								// 

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		jbgID̐ݒ
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwUnitId	jbgIDԍ
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool SetUnitId(unsigned short wDeviceNo, unsigned int dwUnitId)
			{
				try
				{
					return Pas1000SetUnitId(wDeviceNo, dwUnitId);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		jbg擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pdwUnitId	jbgIDi[̈ւ̃|C^
		//			pdwNumCh	jbgɓڂĂAiO`li[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetUnitInfo(unsigned short wDeviceNo, unsigned int* pdwUnitId, unsigned int* pdwNumCh)
			{
				try
				{
					return Pas1000GetUnitInfo(wDeviceNo, pdwUnitId, pdwNumCh);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		̐ݒ
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pdwHostTime	i[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool SetTime(unsigned short wDeviceNo, array<int>^ pdwHostTime)
			{
				try
				{
					bool res;
					int size;
					IntPtr ptr;

					size = Marshal::SizeOf(pdwHostTime[0]) * pdwHostTime->Length;
					ptr = Marshal::AllocHGlobal(size);							// A}l[Wm
					Marshal::Copy(pdwHostTime, 0, ptr, pdwHostTime->Length);	// }l[WA}l[WɃRs[
					res = Pas1000SetTime(wDeviceNo, ptr);
					Marshal::FreeHGlobal(ptr);									// 

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		擾
		// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
		//			pdwFirmTime		t@[v̓i[̈ւ̃|C^
		//			pdwFpgaTime		FPGAv̓i[̈ւ̃|C^
		//			pdwAdjustStatus	AWXg̏Ԃi[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetTime(unsigned short wDeviceNo, array<int>^ pdwFirmTime,
							array<int>^ pdwFpgaTime, unsigned int* pdwAdjustStatus)
			{
				try
				{
					bool res;
					int size;
					IntPtr ptrFirm;
					IntPtr ptrFpga;

					size = Marshal::SizeOf(pdwFirmTime[0]) * pdwFirmTime->Length;
					ptrFirm = Marshal::AllocHGlobal(size);							// A}l[Wm
					Marshal::Copy(pdwFirmTime, 0, ptrFirm, pdwFirmTime->Length);	// }l[WA}l[WɃRs[
					size = Marshal::SizeOf(pdwFpgaTime[0]) * pdwFpgaTime->Length;
					ptrFpga = Marshal::AllocHGlobal(size);
					Marshal::Copy(pdwFpgaTime, 0, ptrFpga, pdwFpgaTime->Length);
					res = Pas1000GetTime(wDeviceNo, ptrFirm, ptrFpga, pdwAdjustStatus);
					Marshal::Copy(ptrFirm, pdwFirmTime, 0, pdwFirmTime->Length);	// A}l[W}l[WɃRs[
					Marshal::Copy(ptrFpga, pdwFpgaTime, 0, pdwFpgaTime->Length);
					Marshal::FreeHGlobal(ptrFirm);									// 
					Marshal::FreeHGlobal(ptrFpga);

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		샂[h̐ݒ
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pSetMode	ݒi[Ă\̂̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool SetMode(unsigned short wDeviceNo, TSETMODE% pSetMode)
			{
				try
				{
					bool res;
					IntPtr ptr;

					ptr = Marshal::AllocHGlobal(Marshal::SizeOf(pSetMode));	// A}l[Wm
					Marshal::StructureToPtr(pSetMode, ptr, false);			// }[VO(}l[W->A}l[W)
					res = Pas1000SetMode(wDeviceNo, ptr);
					Marshal::FreeHGlobal(ptr);								// 

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		fW^͂̓ǂݍ
		// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
		//			pbDigitalInValue	fW^͂i[̈ւ̃|C^B
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool DigitalIn(unsigned short wDeviceNo, Byte* pbDigitalInValue)
			{
				try
				{
					return Pas1000DigitalIn(wDeviceNo, pbDigitalInValue);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		fW^o͂̏
		// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
		//			bDigitalOutValue	fW^o̓f[^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool DigitalOut(unsigned short wDeviceNo, Byte bDigitalOutValue)
			{
				try
				{
					return Pas1000DigitalOut(wDeviceNo, bDigitalOutValue);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		A[̃NA
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwNumCh		`lԍ
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool AlarmClear(unsigned short wDeviceNo, unsigned int dwNumCh)
			{
				try
				{
					return Pas1000AlarmClear(wDeviceNo, dwNumCh);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		MO̊Jn
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwStartMode	Jn[h
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool StartLogging(unsigned short wDeviceNo, unsigned int dwStartMode)
			{
				try
				{
					return Pas1000StartLogging(wDeviceNo, dwStartMode);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		MO̒~
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool StopLogging(unsigned short wDeviceNo)
			{
				try
				{
					return Pas1000StopLogging(wDeviceNo);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		`lʂ̃Xe[^X擾
		// 		wDeviceNo			ΏۃfoCX̃foCXʔԍ
		//			pdwHardNumData		n[hobt@̃MOf[^i[̈ւ̃|C^
		//			pdwSoftNumData		\tgobt@̃MOf[^i[̈ւ̃|C^
		//			pdwLoggingStatus	MOXe[^Xi[̈ւ̃|C^
		//			pdwOverrunError		I[o[G[i[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetStatus(unsigned short wDeviceNo, unsigned int* pdwHardNumData,
							unsigned int* pdwSoftNumData, unsigned int* pdwLoggingStatus,
							unsigned int* pdwOverrunError)
			{
				try
				{
					return Pas1000GetStatus(wDeviceNo, pdwHardNumData, pdwSoftNumData,
												pdwLoggingStatus, pdwOverrunError);
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		`lƂ̃Xe[^X擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			pChStatus	Xe[^Xi[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetChStatus(unsigned short wDeviceNo, TCHSTATUS% pChStatus)
			{
				try
				{
					bool res;
					IntPtr ptr;

					ptr = Marshal::AllocHGlobal(Marshal::SizeOf(pChStatus));	// A}l[Wm
					Marshal::StructureToPtr(pChStatus, ptr, false);				// }[VO(}l[W->A}l[W)
					res = Pas1000GetChStatus(wDeviceNo, ptr);
					pChStatus = safe_cast<TCHSTATUS>(Marshal::PtrToStructure(ptr, TCHSTATUS::typeid));	// }[VO(A}l[W->}l[W)
					Marshal::FreeHGlobal(ptr);									// 

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		MOf[^擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		//			dwNumData	擾f[^
		//			pbData		MOf[^i[̈ւ̃|C^
		// ߂l	 true
		//			s false
		//-----------------------------------------------------------
	public: bool GetData(unsigned short wDeviceNo, unsigned int dwNumData, array<Byte>^ pbData)
			{
				try
				{
					bool res;
					int size;
					IntPtr ptr;

					size = Marshal::SizeOf(pbData[0]) * pbData->Length;
					ptr = Marshal::AllocHGlobal(size);				// A}l[Wm
					Marshal::Copy(pbData, 0, ptr, pbData->Length);	// }l[WA}l[WɃRs[
					res = Pas1000GetData(wDeviceNo, dwNumData, ptr);
					Marshal::Copy(ptr, pbData, 0, pbData->Length);	// A}l[W}l[WɃRs[
					Marshal::FreeHGlobal(ptr);						// 

					return res;
				}
				catch (Exception^ e)
				{
					(void)e;
					return false;
				}
			}
		//-----------------------------------------------------------
		// 		G[R[h擾
		// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
		// ߂l	G[R[h
		//-----------------------------------------------------------
	public: unsigned int GetLastError(unsigned short wDeviceNo)
			{
				try
				{
					return Pas1000GetLastError(wDeviceNo);
				}
				catch (Exception^ e)
				{
					(void)e;
					return ERR_WRAPDLL;
				}
			}
	};
}
