//===================================================================
//	pas1000.h
//
//	Copyright (C) P&A Technologies Inc.
//===================================================================
#ifndef _PAS1000_H_
#define _PAS1000_H_

#ifdef __cplusplus
extern "C" {
#endif


//-------------------------------------------------------------------
// foCXANZXɊւ`
//-------------------------------------------------------------------
#define PAS1000_MAX_DEVICE						16					// őfoCX
#define PAS1000_DEVICE_AUTO						( (WORD)~0U )		// foCXw

//-------------------------------------------------------------------
// `lɊւ`
//-------------------------------------------------------------------
#define PAS1000_ANALOG_NUM_CH					8					// AiO`l
#define PAS1000_EXTRIG_NUM_CH					8					// OgK`l
#define PAS1000_DIGITALOUT_NUM_CH				4					// fW^o̓`l

//-------------------------------------------------------------------
// foCXɊւ`
//-------------------------------------------------------------------
#define PAS1000_VID_LENGTH						8					// x_ʕ
#define PAS1000_PID_LENGTH						16					// v_Ngʕ

//-------------------------------------------------------------------
// ԏɊւ`
//-------------------------------------------------------------------
#define PAS1000_DATE_TIME_LENGTH				7					// ̒(N//(j) ::b)
#define PAS1000_START_TIME_LENGTH				5					// X^[g^C̒(///b/~b)

//-------------------------------------------------------------------
// Xe[^XɊւ`
//-------------------------------------------------------------------
#define PAS1000_STOP_LOGGING					0x00				// MO~
#define PAS1000_RUNNING_LOGGING					0x01				// MOs
#define PAS1000_REACH_START_TIME				0x02				// X^[g^CɒB
#define PAS1000_PRE_START_TRIGPOS				0x04				// X^[ggK|WVɒBO
#define PAS1000_WAIT_START_TRIG					0x08				// X^[ggK҂
#define PAS1000_DETECT_START_TRIG				0x10				// X^[ggKo
#define PAS1000_PRE_STOP_TRIGPOS				0x20				// XgbvgK|WVɒBO
#define PAS1000_WAIT_STOP_TRIG					0x40				// XgbvgK҂
#define PAS1000_DETECT_STOP_TRIG				0x80				// XgbvgKo

//-------------------------------------------------------------------
// G[R[h̒`
//-------------------------------------------------------------------
#define PAS1000_SUCCESS							0x00				// ُȂ
#define PAS1000_ERR_SYSTEM						0x01				// VXeG[
#define PAS1000_ERR_NO_DEVICE					0x02				// gp\ȃfoCX܂
#define PAS1000_ERR_IN_USE						0x03				// w̃foCX͎gpł
#define PAS1000_ERR_INVALID_DEVICENO			0x04				// sȃfoCXʔԍł
#define PAS1000_ERR_INVALID_ARGUMENT			0x05				// sȈw肳܂
#define PAS1000_ERR_INTERNAL					0x06				// G[ł
#define PAS1000_ERR_TRANSFER_TIMEOUT			0x07				// f[^]^CAEgɂȂ܂
#define PAS1000_ERR_TRANSFER_CANCEL				0x08				// f[^]LZ܂
#define PAS1000_ERR_TRANSFER_FAIL				0x09				// f[^]s܂
#define PAS1000_ERR_TRANSFER_SIZE				0x0A				// f[^]̃TCYsł
#define PAS1000_ERR_HARDBUFF_OVERRUN			0x0B				// n[hobt@I[o[܂
#define PAS1000_ERR_SOFTBUFF_OVERRUN			0x0C				// \tgobt@I[o[܂
#define PAS1000_ERR_DEVICE						0x0D				// foCXG[ł
#define PAS1000_ERR_WRAPDLL						( (WORD)~0U )		// DLL ̃[hɎs܂

#define PAS1000_ERR_ANALOG_SETTING				0x01				// AiOɊւݒŕsȈw肳܂
#define PAS1000_ERR_DIGITAL_SETTING				0x04				// fW^ɊւݒŕsȈw肳܂
#define PAS1000_ERR_ALARM_SETTING				0x05				// A[ɊւݒŕsȈw肳܂
#define PAS1000_ERR_TRIGMODE_SETTING			0x06				// gK[hɊւݒŕsȈw肳܂
#define PAS1000_ERR_EXTRIG_SETTING				0x07				// OgKɊւݒŕsȈw肳܂

// AiOɊւݒŕsȈw肳܂
#define PAS1000_ERR_ANALOG_CH_ENABLE			0x10				// `lgp
#define PAS1000_ERR_ANALOG_TYPE					0x11				// ^Cv
#define PAS1000_ERR_ANALOG_RANGE				0x12				// W
#define PAS1000_ERR_ANALOG_BURNOUT				0x13				// o[AEg
#define PAS1000_ERR_ANALOG_COLDJUNCCOMP			0x14				// ړ_⏞
#define PAS1000_ERR_ANALOG_SAMPLINGMODE			0x15				// TvO[h
#define PAS1000_ERR_ANALOG_SAMPLINGTIME			0x16				// TvO^C
#define PAS1000_ERR_ANALOG_STARTTIME_ENABLE		0x17				// X^[g^Cgp
#define PAS1000_ERR_ANALOG_STARTTIME			0x18				// X^[g^C
#define PAS1000_ERR_ANALOG_LOGGINGSIZE			0x19				// MOTCY
#define PAS1000_ERR_ANALOG_STARTTRIG_ENABLE		0x1A				// X^[ggKgp
#define PAS1000_ERR_ANALOG_STARTTRIG_CH			0x1B				// X^[ggK`l
#define PAS1000_ERR_ANALOG_STARTTRIG_MODE		0x1C				// X^[ggK[h
#define PAS1000_ERR_ANALOG_STARTTRIG_SENSE		0x1D				// X^[ggKo[h
#define PAS1000_ERR_ANALOG_STARTTRIG_LEVEL		0x1E				// X^[ggKx
#define PAS1000_ERR_ANALOG_STARTTRIG_POS		0x1F				// X^[ggK|WV
#define PAS1000_ERR_ANALOG_STOPTRIG_ENABLE		0x20				// XgbvgKgp
#define PAS1000_ERR_ANALOG_STOPTRIG_CH			0x21				// XgbvgK`l
#define PAS1000_ERR_ANALOG_STOPTRIG_MODE		0x22				// XgbvgK[h
#define PAS1000_ERR_ANALOG_STOPTRIG_SENSE		0x23				// XgbvgKo[h
#define PAS1000_ERR_ANALOG_STOPTRIG_LEVEL		0x24				// XgbvgKx
#define PAS1000_ERR_ANALOG_STOPTRIG_POS			0x25				// XgbvgK|WV

// OgKɊւݒŕsȈw肳܂
#define PAS1000_ERR_EXTRIG_SLOPE				0x30				// X[v
#define PAS1000_ERR_EXTRIG_FILTER				0x31				// tB^

// A[ɊւݒŕsȈw肳܂
#define PAS1000_ERR_ALARM_ANALOG_ENABLE			0x40				// AiOgp
#define PAS1000_ERR_ALARM_ANALOG_MODE			0x41				// AiO[h
#define PAS1000_ERR_ALARM_ANALOG_SENSE			0x42				// AiOo[h
#define PAS1000_ERR_ALARM_ANALOG_LEVEL			0x43				// AiOx
#define PAS1000_ERR_ALARM_ANALOG_PORTOUT_ENABLE	0x44				// AiO|[go͏
#define PAS1000_ERR_ALARM_ANALOG_PORTOUT_CH		0x45				// AiO|[go̓`l
#define PAS1000_ERR_ALARM_EXTRIG_ENABLE			0x4A				// OgKgp
#define PAS1000_ERR_ALARM_EXTRIG_CH				0x4B				// OgK`l
#define PAS1000_ERR_ALARM_EXTRIG_PORTOUT_ENABLE	0x4C				// OgK|[go͏
#define PAS1000_ERR_ALARM_EXTRIG_PORTOUT_CH		0x4D				// OgK|[go̓`l

// fW^o͂ɊւݒŕsȈw肳܂
#define PAS1000_ERR_DIGITALOUT_TYPE				0x50				// o̓^Cv
#define PAS1000_ERR_DIGITALOUT_LEVEL			0x51				// o͘_

// foCXG[
#define PAS1000_ERR_FPGA_SETTING				0x10				// FPGA:ݒ菈ُł
#define PAS1000_ERR_RTC_INIT					0x20				// RTC:CjVCYُł
#define PAS1000_ERR_RTC_DATA_ACCESS				0x21				// RTC:f[^]ANZXُł
#define PAS1000_ERR_RTC_DATA_SETTING			0x22				// RTC:f[^ݒ肪ُł
#define PAS1000_ERR_RTC_TIME_SETTING			0x23				// RTC:ݒ肪ُł

//-------------------------------------------------------------------
// bZ[W̒`
//-------------------------------------------------------------------
#define WM_REMOVAL								1					// foCX
#define WM_INSERT								2					// foCX}
#define WM_ERROR								3					// f[^擾XbhG[

//-------------------------------------------------------------------
// ̑̒`
//-------------------------------------------------------------------
#define PAS1000_DEVICE_ID						0x5310				// foCXID
#define PAS1000_DLL_NAME						_T( "pas1000.dll" )	// DLLt@C

//-------------------------------------------------------------------
// foCX\
//-------------------------------------------------------------------
typedef struct _tdevinfo {
	BYTE	bVendorID[PAS1000_VID_LENGTH];							// x_ʕ
    BYTE	bProductID[PAS1000_PID_LENGTH];							// v_Ngʕ
    BYTE	bFirmVer;												// t@[EFÃo[W
    BYTE	bFpgaVer;												// FPGÃo[W
	BYTE	bUsbMode;												// USB][h
} TDEVINFO;

//-------------------------------------------------------------------
// 샂[hp[^\
//-------------------------------------------------------------------
// gK@\\
typedef struct _ttrig {
	DWORD		dwEnable;											// gKgpԂ̐ݒ
	DWORD		dwCh;												// gK`l̐ݒ
	DWORD		dwMode;												// gK[h̐ݒ
	DWORD		dwSense;											// gKo[h̐ݒ
	DWORD		dwLevel0;											// gKx0̐ݒ
	DWORD		dwLevel1;											// gKx1̐ݒ
	DWORD64		dwPos;												// gK|WV̐ݒ
} TTRIG;

// AiO@\\(`lʂ̐ݒ)
typedef struct _tanalogch {
	DWORD	dwChEnable;												// AiO`l̐ݒ
	DWORD	dwType;													// AiO^Cv̐ݒ
	DWORD	dwRange;												// AiO̓W̐ݒ
	DWORD	dwBurnOut;												// AiOo[AEg̐ݒ
	DWORD	dwColdJuncComp;											// AiOړ_⏞̐ݒ
} TANALOGCH;

// AiO@\\
typedef struct _tanalog {
	TANALOGCH	Ch[PAS1000_ANALOG_NUM_CH];							// AiO`lʂ̐ݒ
	TTRIG		StartTrig;											// AiOX^[ggK̐ݒ
	TTRIG		StopTrig;											// AiOXgbvgK̐ݒ
	DWORD		dwSamplingMode;										// AiOTvO[h̐ݒ
	DWORD		dwSamplingTime;										// AiOTvO^C̐ݒ
	DWORD		dwStartTimeEnable;									// AiOX^[g^CgpԂ̐ݒ
	DWORD		dwStartTime[PAS1000_START_TIME_LENGTH];				// AiOX^[g^C̐ݒ
	DWORD64		dwLoggingSize;										// AiOMOTCY̐ݒ
} TANALOG;

// OgK\
typedef struct _textrig {
	DWORD	dwInSlope;												// ̓X[v̐ݒ
	DWORD	dwInFilter;												// ̓tB^̐ݒ
} TEXTRIG;

// A[@\̃AiO\
typedef struct _talarmanalog {
	DWORD	dwEnable;												// A[gpԂ̐ݒ
	DWORD	dwMode;													// A[[h̐ݒ
	DWORD	dwSense;												// A[o[h̐ݒ
	DWORD	dwLevel0;												// A[x0̐ݒ
	DWORD	dwLevel1;												// A[x1̐ݒ
	DWORD	dwPortOutEnable;										// A[|[go͏Ԃ̐ݒ
	DWORD	dwPortOutCh;											// A[|[go̓`l̐ݒ
} TALARMANALOG;

// A[@\̊OgK\
typedef struct _talarmextrig {
	DWORD	dwEnable;												// A[gpԂ̐ݒ
	DWORD	dwMode;													// A[[h̐ݒ
	DWORD	dwPortOutEnable;										// A[|[go͏Ԃ̐ݒ
	DWORD	dwPortOutCh;											// A[|[go̓`l̐ݒ
} TALARMEXTRIG;

// A[@\\
typedef struct _talarm {
	TALARMANALOG	Analog[PAS1000_ANALOG_NUM_CH];					// AiÕA[v̐ݒ
	TALARMEXTRIG	ExTrig;											// OgK̃A[v̐ݒ
} TALARM;

// fW^o͍\
typedef struct _tdigitalout {
	DWORD	dwType;													// fW^o̓^Cv̐ݒ
	DWORD	dwLevel;												// fW^o͘_̐ݒ
} TDIGITALOUT;

// 샂[h\
typedef struct _tsetmode {
	TANALOG			Analog;											// AiO@\
	TEXTRIG			ExTrig[PAS1000_EXTRIG_NUM_CH];					// OgK@\
	TALARM			Alarm;											// A[@\
	TDIGITALOUT		DigitalOut[PAS1000_DIGITALOUT_NUM_CH];			// fW^o
} TSETMODE;

//-------------------------------------------------------------------
// `lƂ̃Xe[^X\
//-------------------------------------------------------------------
// MOXe[^X\
typedef struct _tloggingsts {
	DWORD	dwAnalog[PAS1000_ANALOG_NUM_CH];						// AiO
} TLOGGINGSTS;

// `lXe[^X\
typedef struct _tchstatus {
	TLOGGINGSTS		LoggingStatus;									// MOXe[^X
	DWORD			dwAlarmStatus;									// A[Xe[^X
} TCHSTATUS;

//-------------------------------------------------------------------
// API
//-------------------------------------------------------------------
// 
BOOL WINAPI Pas1000Initialize( HWND hWnd, UINT uWMBase, SHORT TimeOut );

// foCX̌
BOOL WINAPI Pas1000Create( PWORD pwDeviceNo );

// foCX̊J
BOOL WINAPI Pas1000Close( WORD wDeviceNo );

// I
BOOL WINAPI Pas1000Terminate( void );

// o[W擾
BOOL WINAPI Pas1000GetVersion( PDWORD pdwDrvVer, PDWORD pdwDllVer );

// foCX擾
BOOL WINAPI Pas1000GetDevInfo( WORD wDeviceNo, TDEVINFO *pDevInfo );

// jbgID̐ݒ
BOOL WINAPI Pas1000SetUnitId( WORD wDeviceNo, DWORD dwUnitId );

// jbg擾
BOOL WINAPI Pas1000GetUnitInfo( WORD wDeviceNo, PDWORD pdwUnitId, PDWORD pdwNumCh );

// ̐ݒ
BOOL WINAPI Pas1000SetTime( WORD wDeviceNo, PDWORD pdwHostTime );

// 擾
BOOL WINAPI Pas1000GetTime( WORD wDeviceNo, PDWORD pdwFirmTime,
							PDWORD pdwFpgaTime, PDWORD pdwAdjustStatus );

// 샂[h̐ݒ
BOOL WINAPI Pas1000SetMode( WORD wDeviceNo, TSETMODE *pSetMode );

// fW^͂̓ǂݍ
BOOL WINAPI Pas1000DigitalIn( WORD wDeviceNo, PBYTE pbDigitalInValue );

// fW^o͂̏
BOOL WINAPI Pas1000DigitalOut( WORD wDeviceNo, BYTE bDigitalOutValue );

// A[̃NA
BOOL WINAPI Pas1000AlarmClear( WORD wDeviceNo, DWORD dwNumCh );

// MO̊Jn
BOOL WINAPI Pas1000StartLogging( WORD wDeviceNo, DWORD dwStartMode );

// MO̒~
BOOL WINAPI Pas1000StopLogging( WORD wDeviceNo );

// `lʂ̃Xe[^X擾
BOOL WINAPI Pas1000GetStatus( WORD wDeviceNo, PDWORD pdwHardNumData, PDWORD pdwSoftNumData,
								PDWORD pdwLoggingStatus, PDWORD pdwOverrunError );

// `lƂ̃Xe[^X擾
BOOL WINAPI Pas1000GetChStatus( WORD wDeviceNo, TCHSTATUS *pChStatus );

// MOf[^擾
BOOL WINAPI Pas1000GetData( WORD wDeviceNo, DWORD dwNumData, PBYTE pbData );

// G[R[h擾
DWORD WINAPI Pas1000GetLastError( WORD wDeviceNo );


#ifdef __cplusplus
}
#endif

#endif
