//===================================================================
//	pas1000w.h
//
//	Copyright (C) P&A Technologies Inc.
//===================================================================
#ifndef __INC_PAS1000W_H__
#define __INC_PAS1000W_H__

#include "pas1000.h"

#ifdef __cplusplus
extern "C"{
#endif


// DLL[h
BOOL Pas1000wDllOpen( void );

// DLLN[Y
BOOL Pas1000wDllClose( void );

// 
BOOL Pas1000wInitialize( HWND hWnd, UINT uWMBase, SHORT TimeOut );

// foCX̌
BOOL Pas1000wCreate( PWORD pwDeviceNo );

// foCX̊J
BOOL Pas1000wClose( WORD wDeviceNo );

// I
BOOL Pas1000wTerminate( void );

// o[W擾
BOOL Pas1000wGetVersion( PDWORD pdwDrvVer, PDWORD pdwDllVer );

// foCX擾
BOOL Pas1000wGetDevInfo( WORD wDeviceNo, TDEVINFO *pDevInfo );

// jbgID̐ݒ
BOOL Pas1000wSetUnitId( WORD wDeviceNo, DWORD dwUnitId );

// jbg擾
BOOL Pas1000wGetUnitInfo( WORD wDeviceNo, PDWORD pdwUnitId, PDWORD pdwNumCh );

// ̐ݒ
BOOL Pas1000wSetTime( WORD wDeviceNo, PDWORD pdwHostTime );

// 擾
BOOL Pas1000wGetTime( WORD wDeviceNo, PDWORD pdwFirmTime,
					  PDWORD pdwFpgaTime, PDWORD pdwAdjustStatus );

// 샂[h̐ݒ
BOOL Pas1000wSetMode( WORD wDeviceNo, TSETMODE *pSetMode );

// fW^͂̓ǂݍ
BOOL Pas1000wDigitalIn( WORD wDeviceNo, PBYTE pbDigitalInValue );

// fW^o͂̏
BOOL Pas1000wDigitalOut( WORD wDeviceNo, BYTE bDigitalOutValue );

// A[̃NA
BOOL Pas1000wAlarmClear( WORD wDeviceNo, DWORD dwNumCh );

// MO̊Jn
BOOL Pas1000wStartLogging( WORD wDeviceNo, DWORD dwStartMode );

// MO̒~
BOOL Pas1000wStopLogging( WORD wDeviceNo );

// `lʂ̃Xe[^X擾
BOOL Pas1000wGetStatus( WORD wDeviceNo, PDWORD pdwHardNumData, PDWORD pdwSoftNumData,
					    PDWORD pdwLoggingStatus, PDWORD pdwOverrunError );

// `lƂ̃Xe[^X擾
BOOL Pas1000wGetChStatus( WORD wDeviceNo, TCHSTATUS *pChStatus );

// MOf[^擾
BOOL Pas1000wGetData( WORD wDeviceNo, DWORD dwNumData, PBYTE pbData );

// G[R[h擾
DWORD Pas1000wGetLastError( WORD wDeviceNo );


#ifdef __cplusplus
}
#endif

#endif // __INC_PAS1000W_H__
